#include "MyAI.h"

MyAI::MyAI(void){}

MyAI::~MyAI(void){}

void MyAI::SetID(int data){
	this->mySeat = data;
}

void MyAI::InitGame(const char* data[]){
	this->openSeat = stoi(data[4]);
	// fprintf(stderr, "%s\n", data); 
}

void MyAI::InitCard(const char* data[]){
	int length = (this->openSeat == this->mySeat) ? 17 : 16;
	for(int i = 1; i <= length; ++i){
		int tileID = stoi(data[i]);
		if(tileID > 100){
			privateHand.AddHand(tileID);
		}
	}
}

void MyAI::DealAsk(const char* data){
	// deal with ask command
	if(!strcmp(data, "throw")){
		this->DealThrow();
	}else if(!strcmp(data, "eat")){
		this->DealEat();
	}else if(!strcmp(data, "pong")){
		this->DealPong();
	}else if(!strcmp(data, "gong")){
		this->DealGong();
	}else if(!strcmp(data, "hu")){
		this->DealHu();
	}
}

void MyAI::DealMo(int tile){
	if(tile > 100){
		privateHand.AddHand(tile);
	}
}

void MyAI::MakeThrow(const char* data[]){	
	int player = stoi(data[1]);
	
	if (player == this->mySeat){
		privateHand.RemoveHand(stoi(data[2]));
	}
}

void MyAI::MakeEat(const char* data[]){
	vector<int> groupTile;
	int player = stoi(data[1]);

	for(int i = 2; i <= 4; ++i){
		groupTile.push_back(stoi(data[i]));
	}
	publicHand[player - 1].AddHand(groupTile);

	if(player == this->mySeat){
		privateHand.RemoveHand(stoi(data[2]));
		privateHand.RemoveHand(stoi(data[4]));
	}	
}

void MyAI::MakePong(const char* data[]){
	vector<int> groupTile;
	int player = stoi(data[1]);

	for(int i = 2; i <= 4; ++i){
		groupTile.push_back(stoi(data[i]));
	}

	publicHand[player - 1].AddHand(groupTile);

	if(player == this->mySeat){
		privateHand.RemoveHand(stoi(data[3]));
		privateHand.RemoveHand(stoi(data[4]));
	}	
}

void MyAI::MakeGong(const char* data[]){
  	int player = stoi(data[1]);
	
	switch (stoi(data[2]))
	{
	case 0: { // Dark Gong
		vector<int> groupTile(4, 0);
		publicHand[player - 1].AddHand(groupTile);

		if(player == this->mySeat){
			privateHand.RemoveHand(stoi(data[3]));
			privateHand.RemoveHand(stoi(data[4]));
			privateHand.RemoveHand(stoi(data[5]));
			privateHand.RemoveHand(stoi(data[6]));
		}	
		break;
	}
	case 1: { // Bu Gong
		publicHand[player - 1].AddBuGong(stoi(data[3]));

		if(player == this->mySeat){
			privateHand.RemoveHand(stoi(data[3]));
		}
		break;
	}
	case 4: { // Ming Gong
		vector<int> groupTile;

		for(int i = 3; i <= 6; ++i){
			groupTile.push_back(stoi(data[i]));
		}
		publicHand[player - 1].AddHand(groupTile);

		if(player == this->mySeat){
			privateHand.RemoveHand(stoi(data[3]));
			privateHand.RemoveHand(stoi(data[4]));
			privateHand.RemoveHand(stoi(data[5]));
			privateHand.RemoveHand(stoi(data[6]));
		}	
		break;	
	}
	default:
		fprintf(stderr, "Error Gong Type\n");
		break;
	}
}

void MyAI::MakeHu(const char* data[]){
	// do something if you want
}

void MyAI::DealFlower(const char* data[]){
	// do something if you want
}

void MyAI::ReadData(){
	// read your data here

	printf("/ready\n");
}

// *********************** AI FUNCTION *********************** //

void MyAI::DealEat(){
	// do something
	printf("/pass\n");
}

void MyAI::DealPong(){
	// do something
	printf("/pass\n");
}

void MyAI::DealGong(){
	// do something
	printf("/pass\n\n");
}

void MyAI::DealHu(){
	// you can choose hu or pass
	printf("/hu\n");
	//printf("/pass\n");
}

void MyAI::DealThrow(){
	srand( time(NULL) );
	vector<int> hand = privateHand.getHand();
	int length = hand.size();

	printf("/throw %d\n", hand[rand() % length]);
}


// *********************** PrivateHand FUNCTION *********************** //

PrivateHand::PrivateHand(void) {
	Hand.clear();
}

PrivateHand::~PrivateHand(void){}

vector<int> PrivateHand::getHand() const {
	vector<int> card;
	for (int i = 0; i < (int)Hand.size(); i++) {
		card.push_back(Hand[i]);
	}
	return card;
}

void PrivateHand::SetHand(const vector<int>& cards) {	
	Hand.clear();
	Hand.resize(cards.size());
	for (int i = 0; i < (int)cards.size(); i++) {
		Hand[i] = cards[i];
	}
}

void PrivateHand::AddHand(const int& card) {
	if (Hand.size() == 17) {
		fprintf(stderr, "***** Wrong size of private hand when adding tiles! Size: %d *****\n", (int)Hand.size());
	}
	Hand.push_back(card);
}

void PrivateHand::RemoveHand(const int& card) {
	vector<int>::iterator it = std::find(Hand.begin(), Hand.end(), card);
	if (it != Hand.end()) {
		Hand.erase(it);
	}
	else {
		fprintf(stderr, "***** Remove Private Hand Error!, Card: %d *****\n", card);
	}
}

void  PrivateHand::RemoveHand(const vector<int>& card) {
	for (int i = 0; i < (int)card.size(); i++) {
		vector<int>::iterator it = std::find(Hand.begin(), Hand.end(), card[i]);
		if (it != Hand.end()) {
			Hand.erase(it);
		}
	}
}

// *********************** PublicHand FUNCTION *********************** //

PublicHand::PublicHand() {
	Hand.reserve(17);
}

PublicHand::~PublicHand() {}

int PublicHand::getGroupNum() const {
	return (int)Hand.size();
}

vector<vector<int>> PublicHand::getHand() const {
	return Hand;
}

void PublicHand::AddHand(const vector<int>& card) {
	Hand.push_back(card);
}

void PublicHand::AddBuGong(const int& card) {
	int a = card / 100;
	int b = (card / 10) % 10;
	vector< vector<int> >::iterator it;
	for (it = Hand.begin(); it != Hand.end(); it++) {
		int tempA = (*it)[0] / 100;
		int tempB = ((*it)[0] / 10) % 10;
		if (tempA == a && tempB == b) {
			(*it).push_back(card);
		}
	}
}