#ifndef MYAI_INCLUDED
#define MYAI_INCLUDED 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <vector>
#include <sstream>
#include <algorithm>

using std::vector;
using std::stoi;

class PublicHand
{
private:
	vector<vector<int>> Hand;

public:
	PublicHand(void);
	~PublicHand(void);

	int getGroupNum() const;

	vector<vector<int>> getHand() const;

	void AddHand(const vector<int>& card);
	void AddBuGong(const int& card);
	void ShowGroup() const;
	void ShowGroupName() const;
};

class PrivateHand
{
private:
	vector<int> Hand;

public:
	PrivateHand(void);
	PrivateHand(const vector<int>& cards);
	~PrivateHand(void);

	vector<int> getHand() const;
	
	void SetHand(const vector<int>& cards);
	void AddHand(const int& card);
	void RemoveHand(const int& card);
	void RemoveHand(const vector<int>& card);
	void ShowPrivateHand() const;
};

class MyAI  
{
public:
	MyAI(void);
	~MyAI(void);

	// commands
	void SetID(int data);
	void InitGame(const char* data[]);
	void InitCard(const char* data[]);
	void DealFlower(const char* data[]);
	void DealAsk(const char* data);
	void DealMo(int data);
	void MakeThrow(const char* data[]);
	void MakeEat(const char* data[]);
	void MakePong(const char* data[]);
	void MakeGong(const char* data[]);
	void MakeHu(const char* data[]);
	void ReadData();

private:
	int mySeat;
	int openSeat;
	PrivateHand privateHand;
	PublicHand publicHand[4];

	// Deal move
	void initGame();
	void DealThrow();
	void DealEat();
	void DealPong();
	void DealGong();
	void DealHu();
};

#endif

