#include <stdio.h>
#include <string.h>
#include "MyAI.h"

int main(){
  char read[1024], write[1024], output[1024], *token;
  const char *data[30];
  bool isFailed;
  MyAI myai;
  do{
    // read command
    fgets(read, 1024, stdin);
    fprintf(stderr, "%s", read);
    // remove newline(\n)
    read[strlen(read) - 1] = '\0';
    // get command name
    token = strtok(read, " ");
    // get command data
    int i = 0;
    while(token != NULL){
      data[i++] = token;
      token = strtok(NULL, " ");
    }

    if(!strcmp(data[0], "/ready")){
      myai.ReadData();
    }
    else if(!strcmp(data[0], "/start")){
      myai.SetID(stoi(data[2]));
    }
    else if(!strcmp(data[0], "/initGame")){
      myai.InitGame(data);
    }
    else if(!strcmp(data[0], "/initCard")){
      myai.InitCard(data);
    }
    else if(!strcmp(data[0], "/mo")){
      myai.DealMo(stoi(data[1]));
    }
    else if(!strcmp(data[0], "/ask")){
      myai.DealAsk(data[1]);
    }
    else if(!strcmp(data[0], "/throw")){
      myai.MakeThrow(data);
    }
    else if(!strcmp(data[0], "/eat")){
      myai.MakeEat(data);
    }
    else if(!strcmp(data[0], "/pong")){
      myai.MakePong(data);
    }
    else if(!strcmp(data[0], "/gong")){
      myai.MakeGong(data);
    }
    else if(!strcmp(data[0], "/hu")){
      myai.MakeHu(data);
    }
    else if(!strcmp(data[0], "/flower")){
      myai.DealFlower(data);
    }
    else if(!strcmp(data[0], "/exit")){
      fprintf(stderr, "The game was finished.\n"); 
      break;
    }

    // important, do not delete
    fflush(stdout);
    fflush(stderr);

  }while(true);

  return 0;
}